require "./lib/pract/grupo.rb"
require "./lib/pract.rb"

class Plate < Grupo
  attr_accessor :name, :plates

   def initialize(name, &block)
      super(name)
      @@plates = []
      @@amount = []
      @@type = []

      if block_given?
         if block.arity == 1
            yield self
         else
            instance_eval(&block)
         end
      end
  end

  def new_plate (val, options = {})

      ingredient = val.name
      ingredient << " (#{options[:amount]})" if options[:amount]


      @@plates << ingredient

      @lista.add_last(val)
      self.calculate
      return val
  end

  def vegetal (val, options = {})
      @@type << 0
      new_plate(val, options)
  end

  def fruta (val, options = {})
      @@type << 1
      new_plate(val, options)
  end

  def cereal (val, options = {})
     @@type << 2
     new_plate(val, options)
  end

  def proteina (val, options = {})
     @@type << 3
     new_plate(val, options)
  end

  def aceite (val, options = {})
     @@type << 4
     new_plate(val, options)
  end

  def to_s_other
     elements = ""
     elements << @name + ": "
     @@plates.each do
         |i| elements << i.to_s + " "#+  @plates[j][0]
     end
     return elements
  end

  def formatted_to_s
     total = 0
     string = @name
     string << "\n#{'=' * @name.size}\n"
     string << "Composicion nutricional:\n\n"
     @lista.each_with_index do
        |i, j|
        string << "#{j + 1}) " + i.name + ": " + ((i.protein_energy* @@amount[j]).round(2)).to_s + "g proteinas, " + ((i.glucid_energy * @@amount[j]).round(2)).to_s + "g glucidos, " + ((i.lipid_energy * @@amount[j]).round(2)).to_s + "g grasas. (" + ((i.energy* @@amount[j]).round(2)).to_s + " g totales)\n"
        total = (total + i.energy* @@amount[j]).round(2)
     end
     string << "\n TOTAL: #{total} g "
     #@instructions.each_with_index do |instruction, index|
   #   string << "#{index + 1}) #{instruction}\n"
   # end

     return string
  end

  def calculate
     @@plates.each_with_index do
         |i, j|
         elements = []
         elements = i.to_s.tr('()','').split(" ")

         amount = 0
         amount = elements[1].to_f * 90 / 20 if (elements[2] == 'lata')
         amount = elements[1].to_f * 30 / 20 if (elements[2] == 'pieza')
         amount = elements[1].to_f * 10 / 20 if (elements[2] == 'cucharada')
         amount = elements[1].to_f / 20 if (elements[2] == 'g')
         @@amount[j] = amount;
     end
     return @@amount
  end
end
